//+====================================================+
//|                               : MACD+.mq4 |
//|                            : karlosslim |
//|                Copyright  2013, "LogicLaboratory" |
//|                          San Francisco, California |
//|                                               2013 |
//+====================================================+
#property copyright "Copyright  2013, LogicLaboratory"
#property link ""
//----------------------------
#property indicator_buffers 2
#property indicator_color1 DodgerBlue    // (DodgerBlue)      Green   C'0,225,113'
#property indicator_color2 C'255,94,255' // (C'255,94,255')   Red
#property indicator_width1 3 // (3)
#property indicator_width2 3 // (3)
//----------------------------
#property indicator_chart_window
//==========================================
extern string      = "";
extern bool   _   =  true;
//----------------------------
extern string MACD_ = "MACD ";
extern int    MACD_FastEMA   = 24; // (24)
extern int    MACD_SlowEMA   = 52; // (52)
extern int    MACD_SignalSMA = 45; // (45)
extern int    MACD_ =  0; //  (0)
//----------------------------
extern string __ATR  = " _ATR";
extern int    _        =  3; //  (3)
extern int    _   =  7; //  (7)
extern int    _ = 12; // (12)
extern int    _      = 12; // (12)
extern color  _        = Silver;  // (Silver)   DimGray   Black   Red   Gray
extern string _       = "Arial"; // ("Arial")
extern int    __ATR  = 12; // (12)
extern int    __ =  4; //  (4)
//----------------------------
extern string _         = " ";
extern color  __     = DarkSlateGray; // (DarkSlateGray)   PaleGreen
extern color  __ = Maroon;        // (Maroon)   Maroon   PaleVioletRed
//----------------------------
extern string _    = " ";
extern int    _ = 500; // (500)
//==========================================
double BoxMACD_Main;
double BoxMACD_Signal;
double BoxBuy[];
double BoxSell[];
bool   BoxBuyFlag  = false;
bool   BoxSellFlag = false;
bool   BuyActive   = false;
bool   SellActive  = false;
bool   BuyAlert    = false;
bool   SellAlert   = false;
datetime t1;
datetime t2;
double HH;
double LL;
int    ctr;
int    CandleNo;
bool   BuyArrow;
bool   SellArrow;
//==========================================
void init() {
   Initialise();
   SetIndexBuffer    (0, BoxBuy);
   SetIndexStyle     (0, DRAW_ARROW,1);
   SetIndexArrow     (0, 233);
   SetIndexEmptyValue(0, EMPTY_VALUE);
   SetIndexLabel     (0, "BuyBox");
   
   SetIndexBuffer    (1, BoxSell);
   SetIndexStyle     (1, DRAW_ARROW,1);
   SetIndexArrow     (1, 234);
   SetIndexEmptyValue(1, EMPTY_VALUE);
   SetIndexLabel     (1, "SellBox");
}
//==========================================
void deinit() {
   Initialise();
}
//==========================================
void start() {
  Initialise();
  for (int i=_; i>CandleNo; i--) {
  CalculateSignals(i); }
  WriteText();
}
//==========================================
void CalculateSignals(int i) {

BoxMACD_Main   = iMACD(NULL,0,MACD_FastEMA,MACD_SlowEMA,MACD_SignalSMA,MACD_,MODE_MAIN,  i);
BoxMACD_Signal = iMACD(NULL,0,MACD_FastEMA,MACD_SlowEMA,MACD_SignalSMA,MACD_,MODE_SIGNAL,i);
BoxBuy[i]  = 0;
BoxSell[i] = 0;

if (BoxMACD_Main > BoxMACD_Signal && !BoxBuyFlag && BoxMACD_Signal != 0) {
    BoxBuy[i] = iLow(NULL,0,i) - iATR(Symbol(), Period(), 60, i) / 1.5;
    BoxBuyFlag  = true;
    BoxSellFlag = false;
    if (_ && BuyArrow != Time[0] && i == 1 && !BuyAlert) {
        BuyArrow = Time[0];
        BuyAlert  = true;
        SellAlert = false;
        Alert(Symbol() + " " + Period() + " -  - BUY !");
    }
}
if (BoxMACD_Main < BoxMACD_Signal && !BoxSellFlag && BoxMACD_Main != 0) {
    BoxSell[i] = iHigh(NULL,0,i) + iATR(Symbol(), Period(), 60, i) / 1.5;
    BoxBuyFlag  = false;
    BoxSellFlag = true;
    if (_ && SellArrow != Time[0] && i == 1 && !SellAlert) {
        SellArrow = Time[0];
        BuyAlert  = false;
        SellAlert = true;
        Alert(Symbol() + " " + Period() + " -  - SELL !");
    }
}
if (iHigh(NULL,0,i) > HH) HH = iHigh(NULL,0,i);
if ( iLow(NULL,0,i) < LL) LL =  iLow(NULL,0,i);

if (BoxBuy[i] > 0) {
   BuyActive = true;
   t1 = iTime(NULL,0,i);
}
if (BoxSell[i] > 0) {
   SellActive = true;
   t2 = iTime(NULL,0,i);
}
if (BuyActive && BoxSell[i] > 0) {
  ObjectCreate("Box_" + ctr, OBJ_RECTANGLE, 0, t2,HH, t1,LL);
  ObjectSet   ("Box_" + ctr, OBJPROP_STYLE, STYLE_SOLID);
  ObjectSet   ("Box_" + ctr, OBJPROP_COLOR, __);
  ObjectSet   ("Box_" + ctr, OBJPROP_BACK, True);
  BuyActive = false;
  HH = 0;
  LL = 9999;
  ctr = ctr + 1;
}
if (SellActive && BoxBuy[i] > 0) {
  ObjectCreate("Box_" + ctr, OBJ_RECTANGLE, 0, t1,LL, t2,HH);
  ObjectSet   ("Box_" + ctr, OBJPROP_STYLE, STYLE_SOLID);
  ObjectSet   ("Box_" + ctr, OBJPROP_COLOR, __);
  ObjectSet   ("Box_" + ctr, OBJPROP_BACK, True);
  SellActive = false;
  HH = 0;
  LL = 9999;
  ctr = ctr + 1;
}}
//==========================================
void WriteText() {
double ATR = iATR(NULL,0,__ATR,1);
TextObj("ATRtxt", " :", _+50, _, _, _, _);
TextObj("ATR", DoubleToStr(ATR*10000*__,0)+"  ", _, _, _, _, _);
}
//==========================================
void TextObj(string objname, string objtext, int hpos, int ypos, color col=Black, string font="Arial", int font_size=8) 
{
ObjectDelete (objname);
ObjectCreate (objname, OBJ_LABEL, 0, 0, 0);
ObjectSet    (objname, OBJPROP_CORNER, _);
ObjectSet    (objname, OBJPROP_XDISTANCE, hpos);
ObjectSet    (objname, OBJPROP_YDISTANCE, ypos);
ObjectSetText(objname,objtext,font_size,font,col);
}
//==========================================
void Initialise() {
   string ObjName;
   int TotObjs = ObjectsTotal();
   for (int i = TotObjs - 1; i >= 0; i--) {
      ObjName = ObjectName(i);
      if (StringSubstr(ObjName,0,4) == "Box_") ObjectDelete(ObjName);
   }
  ObjectDelete("ATRtxt");
  ObjectDelete("ATR");

  ctr = 0;
  LL = 9999;
  HH = 0;
  BuyActive   = false;
  SellActive  = false;
  BoxBuyFlag  = false;
  BoxSellFlag = false;
}
//==========================================
//==========================================
//==========================================